package asm

type Mnemonic uint8

const (
	NONE Mnemonic = iota
	ADD
	CALL
	DIV
	JUMP
	MUL
	LABEL
	MOVE
	POP
	PUSH
	RETURN
	SUB
	SYSCALL
)

// String returns a human readable version.
func (m Mnemonic) String() string {
	switch m {
	case ADD:
		return "add"

	case CALL:
		return "call"

	case DIV:
		return "div"

	case JUMP:
		return "jump"

	case LABEL:
		return "label"

	case MOVE:
		return "move"

	case MUL:
		return "mul"

	case POP:
		return "pop"

	case PUSH:
		return "push"

	case RETURN:
		return "return"

	case SUB:
		return "sub"

	case SYSCALL:
		return "syscall"
	}

	return "NONE"
}
